/******************************************************************************

This is a part of the xHotspot Source code.

Copyright (C) 2006 Sascha Liebsch

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

******************************************************************************/

#include "HotspotGroup.h"

HotspotGroup::HotspotGroup(int const &id, HWND hwnd)
: Hotspot(id, hwnd)
{}

/*virtual*/
HotspotGroup::~HotspotGroup()
{}

void HotspotGroup::AddSubspot(Hotspot *spot)
{
	// only add spot if it is not in the list
	for(std::list<Hotspot*>::iterator i = subspots_.begin(); i != subspots_.end(); ++i)
		if(*i == spot)
			return;
	subspots_.push_back(spot);
	//LSLogPrintf(4, "xHotspot", "%d addsubspot size now: %d", id_, subspots_.size());
}

void HotspotGroup::RemoveSubspot(Hotspot *spot)
{
	subspots_.remove(spot);
} 