/******************************************************************************

This is a part of the xHotspot Source code.

Copyright (C) 2007 Sascha Liebsch

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

******************************************************************************/

#if !defined (HOTSPOTMANAGER_H)
#define HOTSPOTMANAGER_H

#include <string>
#include <vector>
#include <map>

#include "Hotspot.h"
#include "EllipticHotspot.h"
#include "RectHotspot.h"
#include "NormalGroupHotspot.h"
#include "RealGroupHotspot.h"
#include "CustomTypes.h"


typedef std::map<std::string, Hotspot * > spotmap;
typedef std::map<Hotspot *, bool> spotinitmap;

class HotspotManager
{
public:

	HotspotManager(HINSTANCE hInst);

	~HotspotManager();

public:

	Hotspot *AddSpot(std::string const &name, HotspotType const &type, HINSTANCE dll_inst);

	void RemoveSpot(std::string const &name);

	Hotspot *GetSpot(std::string const &name);

	void SetType(std::string const &name, HotspotType const &type);

	void AddInitSpot(Hotspot *spot, bool state);

	void InitSpots();

	static LRESULT WINAPI WindowProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);


private:


private:

	spotmap spots_;

	std::vector<Hotspot *> spot_id_;

	spotinitmap init_;

	int curr_id_;

	HWND hwnd_;

};

static HotspotManager *hotspotmanager;

#endif